/** User Interface Interaction
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 *
 * @required <a href="http://jquery.com/">jQuery</a>
 * @required <a href="http://jqueryui.com/">jQuery UI</a>
 *
 */
"use strict";

$(function(){
	
	/*$(document).on("mousemove",function(e){
	    //console.log(e.currentTarget.activeElement);
	    //console.log(e);
	});*/
	//Refresh content for w2ui framework issue
	$("#tabs > ul a").on("click",function(e){

        //Refresh components dependencies
   //     $.publish("/view/components/refresh/dependencies");

        //Temporary

        
        if(oNode == undefined){
            return;
        }
      //  console.warn("Codice Temporaneo");
        var oMap = oNode.getData();
        var oNode = application.getSelectMap();

        application.selectMap(oNode);
        if (oMap)
        {

        }
        // Rimuovo la lista componenti da mycomponents per metterla nella mappa

	});

    $("#vimarProject").on("submit","form",function(e){
        var $this = $(this);
        var $createRelations = $this.find(".createRelations");
        var $feedbackSimulations = $this.find(".feedbackSimulations");
        window["vimar"] = new Object();

        //Choose XML file
        window["vimar"]["createRelations"] = $createRelations.prop("checked");
        window["vimar"]["feedbackSimulations"] = $feedbackSimulations.prop("checked");

        setTimeout(function(){

            //Choose XML file
            //window["vimar/xml"] = QT.readAnyFile("(*.xml)");
            window["vimar"]["xml"] = QT.readAnyFile("(*.xml)");

            if(window["vimar"]["xml"].length < 1){
                $("#vimarProject").dialog("close");
                return false;
            }

            //XML parser
            $.getScript("./parsers/vimar/byme-xml.js");

            $("#vimarProject").dialog("close");
        },1);
    });

	/** Common icon editor */

	/** Interface */
	
    	/** Interface component received from list */
    	$("#myinterface").on("sortreceive",".level",function(e,ui){
    	    if(ui.sender.hasClass("level") || ui.sender.hasClass(".viewer")){
    	        console.warn("Check send list");
    	        return;
    	    }
            
            var $this = $(this);
            var $helper = ui.helper;
            var $originalItem = ui.item;
            var $dragged = $this.find("li:not([id]):not(.drop-target)");
            //var $element = getInterfaceHtmlElement();
            var oNode = $originalItem.data("eveManagerNode");
            var oParent = $this.data("eveManagerLinkedNode");
            //var oParent = eveManager.getUIComponentsRoot();

            if($this.attr("id") == "level-3" || $this.attr("id") == "level-4"){
                if(oNode == undefined){
                    //$dragged.css("border","solid 1px red");
                    $dragged.remove();
                    return;
                }
            }

            //console.log(oParent);

            //Check if level has a selected node
            if(oParent == undefined){
                console.warn("Any node is select for this level");
                $dragged.remove();
                return;
            }
            
            //Generic icon is dragged
            if(oNode == undefined){
                //var $icon = $originalItem.find(".eve-icon");
               var $icon = $originalItem.find("> span"); 
                
                var strPosition = $icon.css("background-position");
                var aPos = strPosition.split(" ");
                
                var bgX = parseInt(aPos[0],10)* (1/parseFloat($originalItem.attr("application-pan-scale")));
                var bgY = parseInt(aPos[1],10)* (1/parseFloat($originalItem.attr("application-pan-scale")));
                
                var oIconsPan = application.ResoucesManager.getIconsPanById( $originalItem.attr("application-pan-id") );
                //Get default name from HTML
                //var strClass = $icon.attr("class");
                //var strIcon = strClass.slice(strClass.indexOf("eve-icon-")+ "eve-icon-".length);
                var strIcon = _D("Untitled");
                
                //Create parameters
                var oParam = {
                    name: strIcon,
                    icon: {
                        position: { x: bgX, y: bgY },
                        enableColors: false,
                        srcId: oIconsPan["id"],
                        size: { h: oIconsPan["params"]["iconsHeight"], w: oIconsPan["params"]["iconsWidth"] },
                        setSize: { h: oIconsPan["params"]["imgHeight"], w: oIconsPan["params"]["imgWidth"] }
                    }
                };
                oNode = oParam;
            }
            
            //Create new UI component
            var oNewNode = application.addUIComponent(oNode,oParent);
            //console.error(oNewNode);
            
            //Check corrent insert node
            if(oNewNode == undefined){
                return;
            }
            
            //Get new element
            var $element = $("#"+ oNewNode.getData().id);                   //Get created element
            
            $dragged.after($element);                                       //Append element in correct position
            $dragged.remove();                                              //Remove dragged elelment
            
            var newIndex = $this.children().index($element);                //Get new index
            oNewNode.shiftNode(newIndex);                                   //Order memory area in according with new component position//Update position

            application.selectUIComponent(oNewNode);
            
            $.publish("/view/uicomponents/refresh/dependencies");           //Update dependencies
    	});

        /** Interface component received from list */
        $("#mylists").on("sortreceive",".level",function(e,ui){
            if(ui.sender.hasClass("level") || ui.sender.hasClass(".viewer")){
                console.warn("Check send list");
                return;
            }
			
            var $this = $(this);
            var $helper = ui.helper;
            var $originalItem = ui.item;
            var $dragged = $this.find("li:not([list-id]):not(.drop-target)");
            //var $element = getInterfaceHtmlElement();
            var oNode = $originalItem.data("eveManagerNode");
            var oParent = $this.data("eveManagerLinkedNode");
            //var oParent = eveManager.getUIComponentsRoot();
            
            
            
            
            // CHECK IF PARENT IS SCENARIO
            var _TEMP;
            if(oParent != undefined){
            	_TEMP = oParent.getData();
            } 
            //var _TEMP = oParent.getData();
            console.error(_TEMP);
            if(_TEMP != undefined && _TEMP.referenceUId != undefined){
            	console.error(_TEMP.referenceUId);
            	//console.error(application.getComponentByUid(_TEMP.referenceUId));
            	var _COMPONENT = application.getComponentByUid(_TEMP.referenceUId);
            	console.error(_COMPONENT.getData().getType());
            	var _TYPE = _COMPONENT.getData().getType();
            	if(_TYPE == "scenario"){
            		$dragged.remove();
                    return;
            	}
            }
            // CHECK IF PARENT IS SCENARIO
            
            

            if($this.attr("id") == "level-13" || $this.attr("id") == "level-14"){
                if(oNode == undefined){
                    //$dragged.css("border","solid 1px red");
                    $dragged.remove();
                    return;
                }
            }

            //Check if level has a selected node
            if(oParent == undefined){
                console.warn("Any node is select for this level");
                $dragged.remove();
                return;
            }

            //Generic icon is dragged
            if(oNode == undefined){
                //var $icon = $originalItem.find(".eve-icon");
                var $icon = $originalItem.find("> span");

                var strPosition = $icon.css("background-position");
                var aPos = strPosition.split(" ");

                var bgX = parseInt(aPos[0],10)* (1/parseFloat($originalItem.attr("application-pan-scale")));
                var bgY = parseInt(aPos[1],10)* (1/parseFloat($originalItem.attr("application-pan-scale")));

                var oIconsPan = application.ResoucesManager.getIconsPanById( $originalItem.attr("application-pan-id") );
                //Get default name from HTML
                //var strClass = $icon.attr("class");
                //var strIcon = strClass.slice(strClass.indexOf("eve-icon-")+ "eve-icon-".length);
                var strIcon = _D("Untitled");

                //Create parameters
                var oParam = {
                    name: strIcon,
                    icon: {
                        position: { x: bgX, y: bgY },
                        enableColors: false,
                        srcId: oIconsPan["id"],
                        size: { h: oIconsPan["params"]["iconsHeight"], w: oIconsPan["params"]["iconsWidth"] },
                        setSize: { h: oIconsPan["params"]["imgHeight"], w: oIconsPan["params"]["imgWidth"] }
                    }
                };
                oNode = oParam;
            }

            //console.error(oNode);
            //console.error(oParent);

            //Create new UI component
            var oNewNode = application.addUIComponent(oNode,oParent,$this.attr("id"));

            //Check corrent insert node
            if(oNewNode == undefined){
                return;
            }

            //Aggiungere con la view l'elemento

            //Get new element
            //var $element = $("#"+ oNewNode.getData().id);                                     //Get created element
            var $element = $("#mylists").find("[list-id='"+ oNewNode.getData().id+"']");       //Get created element

            $dragged.after($element);                                       //Append element in correct position
            $dragged.remove();                                              //Remove dragged element

            var newIndex = $this.children().index($element);                //Get new index
            oNewNode.shiftNode(newIndex);                                   //Order memory area in according with new component position//Update position

            application.selectUIComponent(oNewNode);

            $.publish("/view/uicomponents/refresh/dependencies");           //Update dependencies
        });
    	
    	/** Update list of interface components */
    	$("#myinterface").on("sortupdate",".level",function(e,ui){
    	    var $this = $(this);
            var $element = ui.item;
            var oNode = $element.data("eveManagerNode");
            var strId = $element.attr("id");
            
            //List reorder
            if(ui.sender == null){
                //Same update inside this level (update node position)
                if($element.parent()[0] === $this[0]){
                    var newIndex = $this.children("[eve-manager-interface-type]:visible").index($element);            //Get new index
                    var error = oNode.shiftNode(newIndex);                      //Order memory area in according with new component position
                }
            }

            //Update in my lists
            var $element2 = $("#mylists").find("[list-id='"+ strId +"']");
            var $parent = $element2.parent();
            var oldIndex = $parent.find("li").index($element2);
            //var $elemOld = $($parent.find("li:not(.drop-target)")[newIndex]);
            var $elemOld = $($parent.find("li")[newIndex]);

            if(oldIndex > newIndex){
                $elemOld.before($element2);
            }
            else{
                $elemOld.after($element2);
            }
        });

        $("#mylists").on("sortupdate",".level",function(e,ui){
            var $this = $(this);
            var $element = ui.item;
            var oNode = $element.data("eveManagerNode");
            var strId = $element.attr("list-id");

            //List reorder
            if(ui.sender == null){
                //Same update inside this level (update node position)
                if($element.parent()[0] === $this[0]){
                    var newIndex = $this.children("[eve-manager-interface-type]:visible").index($element);            //Get new index
                    var error = oNode.shiftNode(newIndex);                      //Order memory area in according with new component position
                }
            }

            //Update in my interface
            var $element2 = $("#myinterface").find("#"+ strId);

            var $parent = $element2.parent();
            var oldIndex = $parent.find("li").index($element2);
            //var $elemOld = $($parent.find("li:not(.drop-target)")[newIndex]);
            var $elemOld = $($parent.find("li")[newIndex]);

            if(oldIndex > newIndex){
                $elemOld.before($element2);
            }
            else{
                $elemOld.after($element2);
            }
        });
    	
    	//Select interface element
    	$("#myinterface .level, #mylists .level").on("mousedown","li:not(.drop-target)",function(e){
    		var $this = $(this);
    		var $level = $this.parent();
    		var $nextLevel = $level.parent().next().find(".level");
    		var oNode = $this.data("eveManagerNode");
    		var oSelectedNode = application.getSelectUIComponent();
    		//var oNodeLevel = $nextLevel.data("eveManagerLinkedNode");
    		
    		//Check if node is already selected
    		//if(oNode === oNodeLevel){ console.log("Same instance"); return; }
    		
    		if(oSelectedNode === oNode){
    		    return;
    		}
    		
    		//INSERIRE NEL PRESENTER
    		//$nextLevel.data("eveManagerLinkedNode",oNode);
    		
    		application.selectUIComponent(oNode);
    	});
    	
    	/** Edit UIComponent */
        $("#interface, #mylists").on("dblclick",".level li:not(.drop-target)",function(e,ui){
            var $this = $(this);
            var $uicomponent = $("#uicomponent-editor");
            var oNode = $this.data("eveManagerNode");
            var oParam = {};
    
            //Open window editor
            presenter.getWindow("componentEditor").show(oNode,oParam);
        });
    	
    	/** Maps */
    	
    	/** Add map */
    	//$("#interface-maps .maps-container > ul").on("click",".add-tab",function(e){
        $("#interface-maps").on("click",".maps-container > ul .add-tab",function(e){
            var oNode = application.getSelectUIComponent();
            var oMapNode = application.addMapTo(oNode);

            //$(this).parents(".maps-container").css("border","solid 1px red");
            $(this).parents(".maps-container").tabs("refresh");

            //Select new Map
            application.selectMap(oMapNode);


            return;//VECCHIO LAVORO
            //Re-select UIComponent
            var oMapNode = application.selectUIComponent(oNode);

            //Select new map from UI (not from memory area)
            $(this).parent().find("[href='#"+ oMap.id +"']").trigger("click");
        });

        /** Select map */
        //$("#interface-maps .maps-container > ul").on("click","li:not(.add-tab)",function(e){
  /*     $("#interface-maps").on("click",".maps-container > ul li:not(.add-tab)",function(e){
            var $this = $(this);
            var oNode = $this.data("MapNodeData");

            //if(oNode === application.getSelectMap()){
             //   return;
            //}

            //Set selected map
            application.selectMap(oNode);
        });
*/


    $("#interface-maps .maps-container").tabs({
        activate: function( event, ui ) {
       //     console.log(event);
       //     console.log(ui);
            var oNode = ui.newTab.data("MapNodeData");
            if (oNode!=undefined)
                application.selectMap(oNode);
        }
    });


    /** Enable/disable grid */
    $("#interface-maps").on("change","#mapEnableGrid",function(e){
        var bValue = $(this).prop("checked");
        presenter.preferences.setInterfacePreferences( "gridEnabled",bValue );

        $("#mapGrid").prop("disabled",!bValue);

        if(bValue){
            var aGrid = presenter.preferences.getInterfacePreference("grid");
            $(".viewer:visible > *").draggable($.extend(true, mapElementsDraggable, { grid:aGrid } ));
            //$(".viewer:visible > *").draggable("option","grid",aGrid );
        }
        else{
            $(".viewer:visible > *").draggable($.extend(true, mapElementsDraggable, { grid:false } ));
            //$(".viewer:visible > *").draggable("option","grid",false);
        }

    });
    $("#interface-maps").on("keyup","#mapGrid",function(e){
        var nGrid = $(this).val();
        if (nGrid==0)
            nGrid=1;
        presenter.preferences.setInterfacePreferences( "grid", [nGrid,nGrid] );

        $(".viewer:visible > *").draggable($.extend(true, mapElementsDraggable, { grid:[nGrid,nGrid] } ));
        //$(".viewer:visible > .map-element").draggable("option","grid",[nGrid,nGrid]);
    });

    /** Enable/disable snap */
    /*$("#interface-maps").on("change","#mapEnableSnap",function(e){
        var bValue = $(this).prop("checked");
        presenter.preferences.setInterfacePreferences( "snapEnabled",bValue );

        $(".viewer:visible > .map-element").draggable("option","snap",bValue);
    });*/
        
    /** Enable/disable map image visibility */
    $("#interface-maps").on("change","#imageVisible",function(e){
        var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
        var oNode = $li.data("MapNodeData");
        var oMap = oNode.getData();
        var oUIComponent = application.getSelectUIComponent().getData();
        var $this = $(this);
        var imageVisible = $this.prop("checked");

        //Update parameters
        $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"imageVisible",imageVisible]);
        $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"imageVisible"]);

        //VECCHIO CODICE

        //Update parameters
        //$.publish("/model/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/update/parameter",[oMap,"imageVisible",imageVisible]);
        //$.publish("/view/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/refresh/parameter",[oMap,"imageVisible"]);
    });

    /** gesturable */
    $("#interface-maps").on("change","#gesturable",function(e){
        var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
        var oNode = $li.data("MapNodeData");
        var oMap = oNode.getData();
        var oUIComponent = application.getSelectUIComponent().getData();
        var $this = $(this);
        var gesturable = $this.prop("checked");

        //Update parameters
        $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"gesturable",gesturable]);
        $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"gesturable"]);
    });


    $("#barChangeColor").click(function(){
        var $colorElement = $(this);
        blr.colorPicker.onChange = function(hsb,hex,rgb,el,bySetColor){
            $colorElement.css("background-color","#"+ hex);
        };
        blr.colorPicker.onClose = function(hex){

        };
        blr.colorPicker.show($colorElement,bigh.textRgb2hex($(this).css("background-color")));
    });
   /*
    $("#barChangeColor").colpick({
        onBeforeShow: function(pickerElem){
            $(this).colpickSetColor(bigh.textRgb2hex($(this).css("background-color")));
        },

        onSubmit: function(param,hex,hue,HTMLelem){
            //Change item background color
            $(HTMLelem).css("background-color","#"+ hex);

            var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
            var oNode = $li.data("MapNodeData");
            var oUser = oNode.getData();
            var oUIComponent = application.getSelectUIComponent().getData();
            var $this = $(this);
            var oColor = {
                R: hue.r,
                G: hue.g,
                B: hue.b
            };

            //Update parameters
            //$.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"color","#"+ hex]);
            $.publish("/model/uicomponent/map/"+ oMap.id +"/update/user",[oMap,"color",oColor]);
            $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/user",[oMap,"color"]);
        }
    });

*/
    /** Enable/disable map trasparence */
        $("#interface-maps").on("change","#mapTransparent",function(e){
            var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
            var oNode = $li.data("MapNodeData");
            var oMap = oNode.getData();
            var oUIComponent = application.getSelectUIComponent().getData();
            var $this = $(this);
            var enableBackground = $this.prop("checked");
            
            //Update parameters
            $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"trasparent",enableBackground]);            
            $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"trasparent"]);
            
            //VECCHIO CODICE
            
            //Update parameters
            //$.publish("/model/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/update/parameter",[oMap,"trasparent",enableBackground]);            
            //$.publish("/view/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/refresh/parameter",[oMap,"trasparent"]);
        });
        
        /** Set map background color */

        $("#mapChangeColor").click(function(){
            var $colorElement = $(this);
            blr.colorPicker.onChange = function(hsb,hex,rgb,el,bySetColor){
                $colorElement.css("background-color","#"+ hex);
            };
            blr.colorPicker.onClose = function(hex){
                $colorElement.css("background-color","#"+ hex);

                var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
                var oNode = $li.data("MapNodeData");
                var oMap = oNode.getData();
                var oUIComponent = application.getSelectUIComponent().getData();
                var $this = $(this);

                var oColor = bigh.hex2rgb(hex);

                //Update parameters
                //$.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"color","#"+ hex]);
                $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"color",oColor]);
                $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"color"]);
            };
            blr.colorPicker.show($colorElement,bigh.textRgb2hex($(this).css("background-color")));
        });

        /*

        $("#mapChangeColor").colpick({
            onBeforeShow: function(pickerElem){
                $(this).colpickSetColor(bigh.textRgb2hex($(this).css("background-color")));
            },
            onShow: function(pickerElem){
                var top = $('#mapChangeColor').position().top - 110;

                $(".colpick_full").css({top:top+'px'});
            },
            onSubmit: function(param,hex,hue,HTMLelem){
                //Change item background color
                $(HTMLelem).css("background-color","#"+ hex);
                
                var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
                var oNode = $li.data("MapNodeData");
                var oMap = oNode.getData();
                var oUIComponent = application.getSelectUIComponent().getData();
                var $this = $(this);
                var oColor = {
                    R: hue.r,
                    G: hue.g,
                    B: hue.b
                };
                
                //Update parameters
                //$.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"color","#"+ hex]);
                $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"color",oColor]);
                $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"color"]);
            }
        });
        */
        /** Load image */
    	$("#interface-maps").on("click","#mapImageLoad",function(e){
            var oUser = application.getSelectUser().getData();
            var path = QT.selectImage(oUser.canvas.w,oUser.canvas.h);
            var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
            var oNode = $li.data("MapNodeData");
            var oMap = oNode.getData();
            var oUIComponent = application.getSelectUIComponent().getData();
            
            //Update parameters
            $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"background",path]);
            $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"background"]);

            //$.publish("/model/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/update/parameter",[oMap,"background",path]);
            //$.publish("/view/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/refresh/parameter",[oMap,"background"]);
        });

        /** Load image */
        $("#interface-maps").on("change","#viewLevel",function(e){

            var $this = $(this);
            var iLevel = parseInt( $this.find(":selected").val(), 10);
            var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
            var oNode = $li.data("MapNodeData");
            var oMap = oNode.getData();

            switch(iLevel){
                case 1:
                    for(var i=0; i<oMap.components.length; ++i){
                        var oMapComponent = oMap.components[i].getData();

                        if(oMapComponent.viewmode != 3){
                            $("#"+ oMapComponent.id).fadeTo( "fast", 1 );
                        }
                        else{
                            $("#"+ oMapComponent.id).fadeTo( "fast", 0.33 );
                        }
                    }
                    break;
                case 2:
                    for(var i=0; i<oMap.components.length; ++i){
                        var oMapComponent = oMap.components[i].getData();

                        if(oMapComponent.viewmode2 != 3){
                            $("#"+ oMapComponent.id).fadeTo( "fast", 1 );
                        }
                        else{
                            $("#"+ oMapComponent.id).fadeTo( "fast", 0.33 );
                        }
                    }
                    break;
                case 3:
                    for(var i=0; i<oMap.components.length; ++i){
                        var oMapComponent = oMap.components[i].getData();

                        if(oMapComponent.viewmode3 != 3){
                            $("#"+ oMapComponent.id).fadeTo( "fast", 1 );
                        }
                        else{
                            $("#"+ oMapComponent.id).fadeTo( "fast", 0.33 );
                        }
                    }
                    break;
                case 4:
                    for(var i=0; i<oMap.components.length; ++i){
                        var oMapComponent = oMap.components[i].getData();

                        if(oMapComponent.viewmode4 != 3){
                            $("#"+ oMapComponent.id).fadeTo( "fast", 1 );
                        }
                        else{
                            $("#"+ oMapComponent.id).fadeTo( "fast", 0.33 );
                        }
                    }
                    break;
                case 5:
                    for(var i=0; i<oMap.components.length; ++i){
                        var oMapComponent = oMap.components[i].getData();

                        if(oMapComponent.viewmode5 != 3){
                            $("#"+ oMapComponent.id).fadeTo( "fast", 1 );
                        }
                        else{
                            $("#"+ oMapComponent.id).fadeTo( "fast", 0.33 );
                        }
                    }
                    break;

            }

            return;
            var oUser = application.getSelectUser().getData();
            var path = QT.selectImage(oUser.canvas.w,oUser.canvas.h);
            var $li = $("#interface-maps .maps-container").find(".ui-tabs-active");     //Get active map
            var oNode = $li.data("MapNodeData");
            var oMap = oNode.getData();
            var oUIComponent = application.getSelectUIComponent().getData();

            //Update parameters
            $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"background",path]);
            $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"background"]);

            //$.publish("/model/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/update/parameter",[oMap,"background",path]);
            //$.publish("/view/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/refresh/parameter",[oMap,"background"]);
        });
    	
    	/** Edit Map */
    	//$("#interface-maps .maps-container > ul").on("click",".ui-icon-gear",function(e){
    	$("#interface-maps").on("click",".maps-container > ul .ui-icon-gear",function(e){
    	    var $li = $(this).parents("li");
    	    var oNode = $li.data("MapNodeData");
    	    var oUIComponentNode = application.getSelectUIComponent();
            presenter.getWindow("componentEditor").show(oNode,oUIComponentNode);
    	});
    	
    	/** Edit Map - double click over tab */
        //$("#interface-maps .maps-container > ul").on("dblclick","li",function(e){
        $("#interface-maps").on("dblclick",".maps-container > ul li",function(e){
            var $li = $(this);
            var oNode = $li.data("MapNodeData");
            var oUIComponentNode = application.getSelectUIComponent();
            presenter.getWindow("componentEditor").show(oNode,oUIComponentNode);
        });
    	
    	/** Map receive component */
    	//$("#interface-maps .maps-container").on("drop",".viewer",function(e,ui){
    	$("#interface-maps").on("drop",".maps-container .viewer",function(e,ui){
    	    //Check
            if(ui.draggable.parent().hasClass("viewer")){
                //--console.log("return");
                return;
            }
            
            var $this = $(this);
            var $draggable = ui.draggable;
            var oNode = $draggable.data("eveManagerNode");
            
            //Check Node
            if(oNode == undefined){
                console.warn("Element's node is undefined");
                return;
            }
            
            var oComponent = oNode.getData();
            var oUIComponent = application.getSelectUIComponent().getData();
            var oMapNode = $this.parent().data("MapNodeData");
            var oMap = oMapNode.getData();
            //var strType = oComponent.getType();
            //var $newElement = getMapElementHtml();
            
            var intTop = (e.pageY - $this.offset().top);
            var intLeft = (e.pageX - $this.offset().left);
            
            //NEW CODE
            //Add component to map
            var oParam = {
                //name: oComponent.getParamVal("name"),
                //reference: oNode
                position:{
                    x: parseInt(intLeft,10) - (oComponent.getParamVal("icons")[0].size.w*0.5),
                    y: parseInt(intTop,10) - (oComponent.getParamVal("icons")[0].size.h*0.5)
                }
            };

            //Check if map has grid active
            var $grid = $("#mapEnableGrid");
            if($grid.prop("checked")){
                //Set position in according with grid
                var iGrid = presenter.preferences.getInterfacePreference("grid")[0];
                oParam.position.x = parseInt(oParam.position.x/iGrid,10)*iGrid;
                oParam.position.y = parseInt(oParam.position.y/iGrid,10)*iGrid;
            }
            
            var oMapComponentNode = application.addComponentToMap(oNode,oMapNode,oParam);

            var oMapComponent = oMapComponentNode.getData();

            var $mapComponent = $("#"+ oMapComponent.id);
            
            //Set element position
            //var intTop = ((e.pageY - $this.offset().top) - $mapComponent.height()/2);
            //var intLeft = ((e.pageX - $this.offset().left) - $mapComponent.width()/2);
            var intTop = oMapComponent.position.y;
            var intLeft = oMapComponent.position.x;
            
            //Check if is out of margin
            if(intTop <= 0){ intTop = 0; }
            if(intTop + $mapComponent.outerHeight() >= $this.height() ){ intTop = $this.height() - $mapComponent.outerHeight(); }
            if(intLeft <= 0){ intLeft = 0; }
            if(intLeft + $mapComponent.outerWidth() >= $this.width() ){ intLeft = $this.width() - $mapComponent.outerWidth(); }
            
            var oPosition = { x:intLeft, y:intTop };
            
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"position",oPosition]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"position",oPosition]);

            application.selectMapComponent(oMapComponentNode);
            return;
            /*$newElement.find(".name").text(oComponent.getParamVal("name"));
            $newElement.find(".icon").addClass("icon-set-state_1");
            $newElement.find(".icon").addClass("icon-set-"+oComponent.getType());
            
            //Append temporary new element
            $this.append($newElement);
            
            //Set element position
            var intTop = ((e.pageY - $this.offset().top) - $newElement.height()/2);
            var intLeft = ((e.pageX - $this.offset().left) - $newElement.width()/2);
            
            //Check if is out of margin
            if(intTop <= 0){ intTop = 0; }
            if(intTop + $newElement.height() >= $this.height() ){ intTop = $this.height() - $newElement.height(); }
            if(intLeft <= 0){ intLeft = 0; }
            if(intLeft + $newElement.width() >= $this.width() ){ intLeft = $this.width() - $newElement.width(); }
            
            var preferences = application.getConfigParam("preferences");
            //console.log(preferences);
            
            var oMapComponentReference = {
                name: oComponent.getParamVal("name"),
                reference: oNode,
                referenceMap: oMap,
                position:{
                    x: parseInt(intLeft,10),
                    y: parseInt(intTop,10)
                },
                scaleFactor: preferences.interface.iconsScaleFactor
            };
            
            $newElement.remove();
            
            //Publish for saving in Model and draw in view
            $.publish("/model/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/update/component/new",[oMap,oMapComponentReference]);
            $.publish("/view/uicomponents/"+ oUIComponent.id +"/map/"+ oMap.id +"/refresh/component/draw",[oMap,oMapComponentReference]);
            */
    	});
    	
    /** Map drag component */
    $("#interface-maps").on("dragstart",".maps-container .viewer > *",function(e,ui){
        //console.log("drag start1");
        var $this = $(this);
        var oNode = $this.data("eveManagerNode");
        if (oNode!=undefined)
        {
            var oMapComponent = oNode.getData();
            var oPosition = $.extend(true,{},oMapComponent).position;
            return;
            console.error(oPosition);

            //Check if map has grid active
            var $grid = $("#mapEnableGrid");
            if(!$grid.prop("checked")){
                return;
            }

            //Set position in according with grid
            var iGrid = presenter.preferences.getInterfacePreference("grid")[0];
            oPosition.x = parseInt(oPosition.x/iGrid,10)*iGrid;
            oPosition.y = parseInt(oPosition.y/iGrid,10)*iGrid;

            console.warn(oPosition.x);
            console.warn(oPosition);
            console.warn(ui.position);

            $("#"+ oMapComponent.id).css("border","solid 1px red");

            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"position",oPosition]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"position"]);

        }
    });
    /*$("#interface-maps").on("drag",".maps-container .viewer > *",function(e,ui){
        var oPosition = {
            x:  parseInt(ui.position.left,10),
            y: parseInt(ui.position.top,10)
        };

        var oPosition2 = {
            x:  ui.position.left,
            y: ui.position.top
        };

        console.error(oPosition);
        console.error(oPosition2);
    });*/
    $("#interface-maps").on("dragstop",".maps-container .viewer > *",function(e,ui){
        var $this = $(this);
        var $viewer = $this.parent();
        var oNode = $this.data("eveManagerNode");
        var oMapComponent = oNode.getData();
        var oPosition = {
            x:  parseInt(ui.position.left,10),
            y: parseInt(ui.position.top,10)
        };

        //Check position
        if(oPosition.x < 0){
            oPosition.x = 0;
        }
        if(oPosition.y < 0){
            oPosition.y = 0;
        }
        if(oPosition.x > $viewer.width()-20 ){
            oPosition.x = $viewer.width()-20;
        }
        if(oPosition.y > $viewer.height()-20){
            oPosition.y = $viewer.height()-20;
        }

        //Change only model
        $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"position",oPosition]);
        $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"position",oPosition]);
        //console.error(oPosition);
    });

    /** Map select component */
    $("#interface-maps").on("mousedown",".maps-container .viewer > *",function(e,ui){
        var $this = $(this);
        var oNode = $this.data("eveManagerNode");

        if(oNode == undefined){
            return;
        }

        var oMapComponent = oNode.getData();
        var oPosition = $.extend(true,{},oMapComponent).position;

        application.selectMapComponent(oNode);

        //Check if map has grid active
        var $grid = $("#mapEnableGrid");
        if(!$grid.prop("checked")){
            return;
        }
// al primo click non bisogna allineare l'icona per evistare spostamenti involuti
     /*   //Set position in according with grid
        var iGrid = presenter.preferences.getInterfacePreference("grid")[0];
        oPosition.x = parseInt(oPosition.x/iGrid,10)*iGrid;
        oPosition.y = parseInt(oPosition.y/iGrid,10)*iGrid;
*/
        $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"position",oPosition]);
        $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"position"]);
    });
        
    /** Edit UIComponent */
    $("#interface").on("dblclick",".viewer > .map-element",function(e,ui){
        var $this = $(this);
        var oNode = $this.data("eveManagerNode");
        var oMapNode = application.getSelectMap();

        //Edit
        presenter.getWindow("componentEditor").show(oNode,oMapNode);
    });

    /** Relations */

    /** Add relations element
     *
     */
    $("#myrelations").on("click",".ui-widget-header .ui-icon-plusthick",function(e){
        var oNode = application.addRelation();
    });
    //Drop a component
    $("#myrelations").on("drop",".source",function(e,ui){
        var $this = $(this);
        var $relation = $this.parents(".relation");
        var oComponentNode = ui.helper.data("eveManagerNode");
        var oNode = $relation.data("eveManagerNode");
        var oRelation = oNode.getData();

        $.publish("/model/relations/"+ oRelation.id +"/update/parameter",[oRelation,"source",oComponentNode]);

        $.publish("/view/relations/"+ oRelation.id +"/refresh/parameter",[oRelation,"source"]);
    });
    $("#myrelations").on("drop",".destination",function(e,ui){
        var $this = $(this);
        var $relation = $this.parents(".relation");
        var oComponentNode = ui.helper.data("eveManagerNode");
        var oNode = $relation.data("eveManagerNode");
        var oRelation = oNode.getData();

        $.publish("/model/relations/"+ oRelation.id +"/update/parameter",[oRelation,"destination",oComponentNode]);

        $.publish("/view/relations/"+ oRelation.id +"/refresh/parameter",[oRelation,"destination"]);
    });
    $("#myrelations").on("update/relation",".incomplete",function(e,ui){
        var $this = $(this);
        var $source = $this.find(".source");
        var $destination = $this.find(".destination");
        var oSourceNode = $source.data("eveManagerNode");
        var oDestNode = $destination.data("eveManagerNode");
        var operator = $this.find(".operator").attr("operator");

        //Check source
        if(oSourceNode == undefined){
            return;
        }

        //Check destination
        if(oDestNode == undefined){

            //Enable destination
            $destination.removeClass("ui-state-disabled").droppable("enable");
            return;
        }

        $this.removeClass("incomplete");

        var oNode = application.addRelation(oSourceNode,oDestNode,operator);
        var oRelation = oNode.getData();
        var $relation = $("#myrelations").find("#"+ oRelation.id);

        $this.after($relation);
        $this.remove();
    });

    $("#myrelations").on("click",".relation .remove",function(e){
        var $relation = $(this).parents(".relation");
        application.removeRelation($relation.data("eveManagerNode"));
});

	/** Components */
	
	//var strComponentsSelector = "[eve-manager-component]:not([eve-manager-component='group']),[eve-manager-component='group']>ul [eve-manager-component],[eve-manager-component='group'] > h3";
	var strComponentsSelector = "[eve-manager-component]:not([eve-manager-component='group']), [eve-manager-component='group'] > h3";


    /** Add group + icon element
     *
     */
    $("#mycomponents").on("click",".ui-widget-header .ui-icon-plusthick",function(e){
        application.selectComponent( application.addComponent( {type: "group"} ) );
    });

	//Select components/group from html
    /*
    $("#componentscontainer").on("mousedown",strComponentsSelector,function(e){

    //Select components/group from html
    // Send Selected component to the presente
    // #componentscontainer Container of my components
    // #interface-components List container of componente visible in the map builder
    // 
    //$("#componentscontainer,#interface-components").on("mouseup",strComponentsSelector,function(e){
    $("#componentscontainer").on("mouseup", strComponentsSelector, function (e) {
        var $this = $(this);
		if($this.attr("eve-manager-component") == undefined){
			//Accordion header is clicked
			$this = $this.parent();
			if($this.attr("eve-manager-component") == undefined){
                console.error("Wrong selected component or group");
            }
		}
		
		var oNode = $this.data("eveManagerNode");									//Get linked node

//      console.log("Group clicked ");

		//Trigger for check name or parameters
		$("#componentproperties [eve-manager-id]").trigger("onblur");

/*
        if(application.getSelectComponent() != oNode){
            application.selectComponent(oNode,$this);
        }
*/  /*    application.selectComponent(oNode,$this);
        										//Select node
	});
*/
 /*   $("#interface-components,#lists-components").on("mousedown",strComponentsSelector,function(e){

        var $this = $(this);
        if($this.attr("eve-manager-component") == undefined){
            //Accordion header is clicked
            $this = $this.parent();
            if($this.attr("eve-manager-component") == undefined){
                console.error("Wrong selected component or group");
            }
        }

        var oNode = $this.data("eveManagerNode");									//Get linked node
        application.selectComponentInMap(oNode,$this);

    });
*/

    /** Component creation after sortable receive
	 * 
	 */
    //$("#mycomponents").on("sortreceive","#componentscontainer",function(e,ui){
    $("#mycomponents").on("sortreceive","#componentscontainer, #componentscontainer [eve-manager-component='group'] > ul",function(e,ui){

        //alert();
        /*
        console.error(e);
        console.error(ui);
        console.error($("#componentscontainer").position());
        console.error($("#componentscontainer").offset());
        //$(e.target).css("border","solid 10px red");
        */

        if(!$(e.target).is(":visible")){
            //console.warn("Bug occured");
            //$(this).find("> *:not([id])").css("border","solid 10px red");         //Find dragged element
            $(this).find("> *:not([id])").remove();         //Find dragged element
            //console.error(ui);
            e.stopPropagation();
            return;
        }

	    // Stop event propagation
	    e.stopPropagation();

        //console.warn(e.type);
        
	    var $this = $(this);
	    var $parent = $this.parent();
	    var oParent = $parent.data("eveManagerNode");
	    var $item = ui.item;
        var oNode = $item.data("eveManagerNode");
        var strType = $item.attr("eve-manager-component");
        
        //Check parent
        if(oParent == undefined){
            //Dragged on root
            $parent = $this;
            oParent = $this.data("eveManagerNode");
            //oParent = eveManager.getComponentsRoot();
        }

        //Re-check parent node
        if(oParent == undefined){
            console.error("Parent node is undefined");
            return;
        }
        
        //Check item origin
        if(oNode != undefined){
            //Dreagged from another list
            return;
        }

        //Create component & select it
        var oNode = application.addComponent(strType,oParent);

        //Check corrent insert node
        if(oNode == undefined){
            return;
        }
        
        //application.selectComponent(oNode);
        
        //Get new element
        var $element = $("#"+ oNode.getData().id);                      //Get created element
        var $dragged = $element.parent().find("> *:not([id])");         //Find dragged element
        $dragged.after($element);                                       //Append element in correct position
        $dragged.remove();                                              //Remove dragged element
        
        var newIndex = $parent.children().index($element);              //Get new index
        oNode.shiftNode(newIndex);                                      //Order memory area in according with new component position//Update position

     //   $.publish("/view/components/refresh/dependencies");             //Update dependencies

        application.selectComponent(oNode);
	});
	
	/** Component position update after sortable update
     * 
     */
    $("#mycomponents").on("sortupdate","#componentscontainer, #componentscontainer [eve-manager-component='group'] > ul",function(e,ui){
        e.stopPropagation();
        var $this = $(this);
        var $component = ui.item;        
        var $parent = $this.parent();
        var oParent = $parent.data("eveManagerNode");
        var oNode = $component.data("eveManagerNode");
        var $childs = $this.children();
        
        //Check node
        if(oNode == undefined){
            //Element is just created
            return;
        }
        
        //Check parent
        if(oParent == undefined){
            //Dragged on root
            $parent = $this;
            oParent = $parent.data("eveManagerNode");
        }
        
        //Re-check parent node
        if(oParent == undefined){
            console.error("Parent node is undefined");
            return;
        }
        
        //Update memory struct
        if(oParent !== oNode.getParent()){
            var oComponent = oNode.getData();
            oParent.addChild(oNode);
            oComponent.parentUId = oParent.getData().UId;
        }
        
        //Search on sortable list ($this variable, not $parent)
        var newIndex = $this.children().index($component);              //Get new index
        oNode.shiftNode(newIndex);                                      //Order memory area in according with new component position
        
        $.publish("/view/components/refresh/dependencies");             //Update dependencies
    });

    /** Component position update after sortable update
     *
     */
    /*$("#mycomponents").on("mouseover","#componentscontainer [eve-manager-component='group'] > h3",function(e){
        console.warn(e);
    });*/
	
	/** Remove component button (load from "./components/mainframe/bottom-prop.html")
	 * 
	 */
	$("#componentproperties").on("click",".remove-component",function(e){
	    var oNode = application.getSelectComponent();
	    var oComponent = oNode.getData();
	    var $nextElement = $("#"+ oComponent.id).next();
	    var oNextNode = $nextElement.data("eveManagerNode");
	    
	    if(oComponent.getParamVal("special") != undefined){
	        console.warn("Can not remove "+ oComponent.getParamVal("special") +" component");
	        return;
	    }

        $document.trigger("app/confirm",["Selected component will be removed. Continue?",function(){
            application.removeComponent(oNode);
            application.selectComponent(oNextNode);
        }]);

	});
	
	/** Change icon */
	$("#componentproperties").on("dblclick","[eve-manager-id='icons'] .icon",function(e){
        var oNode = application.getSelectComponent();
        var oComponent = oNode.getData();
        var $this = $(this);
        var oParam = {
            status: parseInt($this.find("span").text(),10)
        };

        //Open window editor
        presenter.getWindow("iconEditor").show(oNode,oParam);
    });
	
	/** Update components dependencies when change some input values inside component properties
     * 
     */
    $("#componentproperties").on("change","[eve-manager-components='mainframe'] .eve-manager",function(e){
        $.publish("/view/components/refresh/dependencies");
    });
	
	/** Select gateway choosing protocol from component (component properties)
     * 
     */
	$("#componentproperties").on("change","[eve-manager-id='gateway']",function(e){
	   application.selectGateway($(this).find(":selected").data("eveManagerNode"));
	});


    $("#components-finder").keyup(function(){


        // cerca tutti i componenti cha hanno dentro la stringa cercata nella serializzazione

        var valueToSearch = $(this).val();
        var trovatoUnico;

        function searchInside(oNode){
            var oData=oNode.getData();

            try
            {

                if (oData.search(valueToSearch))
                {
                    // console.log("trovato");
                    // console.log(oData.parentUId);
                    // oData.HTMLViewReference.css('border-color','#FF0000');

                    try{ oData.HTMLViewReference.css('background' ,'url(css/plugin/jquery/themes/ui-darkness/images/ui-bg_glass_40_0078a3_1x400.png) 50% 50% repeat-x');}catch(e){};
                    while (oData.parentUId!=undefined)
                    {

                        oData=eveManager.getComponentByUid(oData.parentUId).getData();
                        try{

                            var gruppoHeader=oData.HTMLViewReference.find(".ui-accordion-header").first();
                            //console.log(gruppoHeader);
                            //gruppoHeader.css('border-color','rgb(205,185,224)');
                            gruppoHeader.css("background",'url(css/plugin/jquery/themes/ui-darkness/images/ui-bg_glass_40_0078a3_1x400.png) 50% 50% repeat-x');
                        }catch (e) {};
                    }
                }
            }
            catch (e)
            {

            }
            for(var i=0;i<oNode.children.length;++i){
                searchInside(oNode.children[i]);
            }
        };


        function deSearch(oNode){
            var oData=oNode.getData();

            try
            {
                try{
                    oData.HTMLViewReference.css('background' ,'');
                }
                catch(e){};


                while (oData.parentUId!=undefined)
                {
                    oData=eveManager.getComponentByUid(oData.parentUId).getData();
                    // console.log(oData);
                    try{

                        //console.log(oData);
                        var gruppoHeader=oData.HTMLViewReference.find(".ui-accordion-header").first();
                        //console.log(gruppoHeader);
                        //gruppoHeader.css('border-color','rgb(205,185,224)');

                        gruppoHeader.css("background",'url(css/plugin/jquery/themes/ui-darkness/images/ui-bg_glass_20_555555_1x400.png) 50% 50% repeat-x');
                    }catch(e){};
                }
            }
            catch (e)
            {

            }
            for(var i=0;i<oNode.children.length;++i){
                deSearch(oNode.children[i]);
            }
        };

        var oComponentRoot = eveManager.getComponentsRoot();
        for(var i=0;i<oComponentRoot.children.length;++i){
            deSearch(oComponentRoot.children[i]);
        }
        for(var i1=0;i1<oComponentRoot.children.length;++i1){
            searchInside(oComponentRoot.children[i1]);
        }
    });


    /*  $("#components-finder").keyup(function(){
          //var value = $(this).val();//.toLowerCase();
          var value = $(this).val().toLowerCase();
          var $elems = $("#componentscontainer").find("[name*='"+ value +"']:not(.special)");

          if(value.length > 0){
              $("#componentscontainer").find("[eve-manager-component]:not(.special)").hide();
              $elems.show();

              $elems.parents("[eve-manager-component='group']").show();

              var oNode = application.getComponentByUid(value);
              if(oNode != undefined){
                  var oComponent = oNode.getData();
                  $elems = $("#"+ oComponent.id);
                  $elems.show();
                  $elems.parents("[eve-manager-component='group']").show();
              }

              //$elems.parents("[eve-manager-component='group']").accordion("open");
              //$elems.css("border","solid 1px red");
          }
          else{
              $("#componentscontainer").find("[eve-manager-component]:not(.special)").show();
              $elems.parents("[eve-manager-component='group']").show();

              //$elems.css("border","solid 1px inherit");
          }

          //$elems.css("border","solid 1px red");
          //console.log($elems.length);
      });


      */

    $("#interface-elements #interface-components").on("keyup",".finder > input",function(){
        //var value = $(this).val();//.toLowerCase();
        var value = $(this).val().toLowerCase();
        //var $elems = $("#interface-components").find("[name*='"+ value +"']:not(.special)");
        var $elems = $("#interface-components").find("[name*='"+ value +"']");


        if(value.length > 1){
            $("#interface-components").find("[eve-manager-component]:not(.special)").hide();
            $elems.show();
            $elems.parents("[eve-manager-component='group']").show();
            //$elems.parents("[eve-manager-component='group']").accordion("open");
            //$elems.css("border","solid 1px red");
        }
        else{
            $("#interface-components").find("[eve-manager-component]:not(.special)").show();
            //$elems.css("border","solid 1px inherit");
        }

        //$elems.css("border","solid 1px red");
        //console.log($elems.length);
    });
	
	//Node Dump
	$("#componentscontainer").on("click","*",function(e){
		//console.warn($("#componentscontainer").data("eveManagerNode").dump(["data","m_Data","name"]));
		//alert($(this).data("eveManagerNode").dump(["data","m_Data","name"]));
	});
	
	
	/** Gateways */
	
    /** On update gateway list
     *
     */
    $("#mygateways").on("sortupdate",".gateways",function(e,ui){
        var $this = $(this);
        var $gateway = ui.item;
        var oNode = $gateway.data("eveManagerNode");
        var newIndex = $this.children().index($gateway);                //Get new index
        oNode.shiftNode(newIndex);                                      //Order memory area in according with new component position

        //Refresh dependencies
        $.publish("/view/gateways/refresh/dependencies");
    });

    /** Add gateway element
     *
     */
    $("#mygateways").on("click",".ui-widget-header .ui-icon-plusthick",function(e){
        application.selectGateway( application.addGateway() );
    });

    /** Select gateway element
     *
     */
    $("#mygateways .gateways").on("mousedown",".gateway",function(e){
        var $this = $(this);
        var oNode = $this.data("eveManagerNode");

        application.selectGateway(oNode);
    });

    /** Remove gateway list
     *
     */
    $("#mygateways").on("click",".gateways .remove",function(e,ui){
        //Ask if remove gateway
        var $this = $(this);
        var $gateway = $this.parents(".gateway");
        var oNode = $gateway.data("eveManagerNode");

        $document.trigger("app/confirm",["Selected gateway will be removed. Continue?",function(){
            application.removeGateway(oNode);
        }]);

    });

    $("#gateway-properties").on("click",".remove-gateway",function(e,ui){
        //Ask if remove gateway
        var oNode = application.getSelectGateway();

        $document.trigger("app/confirm",["Selected gateway will be removed. Continue?",function(){
            application.removeGateway(oNode);
        }]);
    });

    /** Test Components */
    $("#mycomponents").on("click","[eve-manager-component='switch'] .eve-values",function(e,ui){
        var $this = $(this);
        var $component = $this.parents("[eve-manager-component]");
        var oNode = $component.data("eveManagerNode");
        var oComponent = oNode.getData();

        if($this.text().toLowerCase() == "on"){
            //--console.log(oComponent.UId,"string",0);
            QT.sendParameterValue(oComponent.UId,"byte",0);
        }
        else{
            //--console.log(oComponent.UId,"string",0);
            QT.sendParameterValue(oComponent.UId,"byte",1);
        }
    });
        
    //Update dependencies
    /*$("#gateway-properties .container").on("change","[eve-manager-type]",function(e,ui){
        $.publish("/view/gateways/refresh/dependencies");
    });*/

    /** Plugin */
    $("#plugins").on("click",".download",function(e,ui){
        var $this = $(this);
        var $li = $this.parents("li");
        var srcUrl = $this.attr("eve-manager-url");
        var pluginInfo = $.extend(true, {}, $li.data("pluginInfo") );

        $document.trigger("app/load/begin",[_D("Downloading plugin")]);

        pluginInfo.localurl = "../plugins/"+ $li.attr("eve-manager-plugin") +".tar.gz"

        window["eve/plugin"] = {
            id: $li.attr("eve-manager-plugin"),
            info: pluginInfo
        };

        QT.downloadFile(srcUrl,"/data/plugins/"+ $li.attr("eve-manager-plugin") +".tar.gz",function(){
            //console.log();

            $document.trigger("app/load/end");
            QT.writeFile("../plugins/downloads/"+ window["eve/plugin"].id +".json",JSON.stringify( window["eve/plugin"].info ));

            delete window["eve/plugin"];
            $("#plugins").dialog("open");
        });

        $("#plugins").dialog("close");
    });

    $("#plugins").on("click",".install",function(e,ui){
        var $this = $(this);
        var $li = $this.parents("li");
        var srcUrl = $this.attr("eve-manager-url");
        var pluginInfo = $.extend(true, {}, $li.data("pluginInfo") );

        /*window["eve/plugin"] = {
            id: $li.attr("eve-manager-plugin"),
            info: pluginInfo
        }*/

        /*QT.uploadTo(srcUrl,"/data/plugins/"+ $li.attr("eve-manager-plugin") +".tar.gz",function(){

            delete window["eve/plugin"];
        });*/
        if(QT.eve.isConnect()){
            //console.error(srcUrl);
            //--console.log(pluginInfo);
            //console.error("http://"+ window["eve"]["ip"] + pluginInfo.initscript);


            //console.log( QT.applicationPath() +"/data/html/"+ pluginInfo.localurl);
            window["eve/plugin"] = {
                id: pluginInfo.id,
                info: pluginInfo
            };

            $document.trigger("app/load/begin",["Upload plugin","bar"]);

            //QT.eve.copyFile(QT.applicationPath() +"/data/html/"+ pluginInfo.localurl, pluginInfo.id +".tar.gz",function(json){
            QT.eve.installPlugin(QT.applicationPath() +"/data/html/"+ pluginInfo.localurl,pluginInfo.installpath,function(json){

                $("#loader").find(".progressbar").progressbar("value", parseInt(json["percent"],10));

                if(json.status.toLowerCase() != "complete"){
                    return;
                }

                $("#loader").find(".progressbar").progressbar("value", 100);
                $document.trigger("app/load/end");
                $document.trigger("app/load/begin",["Installing plugin..."]);

            },
            function(json){
                //console.log(json);
                if(json.status.toLowerCase() != "install complete"){
                    return;
                }

                $.getScript("http://"+ window["eve"]["ip"] + window["eve/plugin"].info.initscript);

                delete window["eve/plugin"];
                $document.trigger("app/load/end");
            });

            /*$.getScript("http://"+ window["eve"]["ip"] + pluginInfo.initscript).done(function(){

            });*/

            //$("#plugins").dialog("close");
        }
        else{
            $document.trigger("app/confirm",[_D("You must to be connected to Eve.<br />Connect now?"),function(){
                presenter.getWindow("databaseManager").show(undefined, { "command": "connect" });
            }]);
        }
    });

    $("#plugins").on("click",".config",function(e,ui){
        var $this = $(this);
        var $li = $this.parents("li");
        //var srcUrl = $this.attr("eve-manager-url");
        var pluginInfo = $.extend(true, {}, $li.data("pluginInfo") );

        if(QT.eve.isConnect()){
            //--console.log(pluginInfo);
            $.getScript("http://"+ window["eve"]["ip"] + pluginInfo.configscript);
        }
        else{
            $document.trigger("app/confirm",[_D("You must to be connected to Eve.<br />Connect now?"),function(){
                presenter.getWindow("databaseManager").show(undefined, { "command": "connect" });
            }]);
        }

        //$("#plugins").dialog("close");
    });

    $("#plugins").on("click",".remove",function(e,ui){
        var $this = $(this);
        var $li = $this.parents("li");
        //var srcUrl = $this.attr("eve-manager-url");
        var pluginInfo = $.extend(true, {}, $li.data("pluginInfo") );
			
        if(QT.eve.isConnect()){     
            if(pluginInfo.removescript !== undefined && pluginInfo.removescript.trim() != '') {    
	            $.getScript("http://"+ window["eve"]["ip"] + pluginInfo.removescript);
	            eveDesk.EVEMessageSend("exitEvelogic||exitEvelogic|", function(data){console.log("evelogic.exe stopped, waiting for restart...");});
            	$li.find('.upload-plugin').removeProp('checked');
            	$("#plugins-span-update-to-eve").text(pluginInfo.name + _D(" removed from EVE"));
            }
        }
        else {
            $document.trigger("app/confirm",[_D("You must to be connected to Eve.<br />Connect now?"),function(){
                presenter.getWindow("databaseManager").show(undefined, { "command": "connect" });
            }]);
        }
        //$("#plugins").dialog("close");
    });

    $("#plugins-start-local-update").on("click", function(e,ui){
  		
     	$.ajax({
            url: "http://www.ilevia.com/eve/plugins20150508/list.php",
            dataType: "jsonp",
            cache : false,
            complete: function(){
               // $this.find("p img").hide();
            },
            success: function(json){
            	
            	var pluginsToDownload = new Array();
    	       	         	        	
            	//list of local files
            	var aDownloadsList = QT.fileList(QT.applicationPath()+"/data/plugins/downloads/");
            	
    		    var localPluginNumber = 0;
            	for(var i=0; i<aDownloadsList.length; ++i){
           			if(aDownloadsList[i].name.indexOf(".json") == -1)
	                	continue;
	                else
	                	localPluginNumber++;
            	}
            	
            	//check if there is a new plugin
        		if(localPluginNumber < json.length) {      			 
        			for(var i=0; i<json.length; ++i){
        				var found = false;
        				for(var j=0; j<aDownloadsList.length; ++j){
        					
        					if(aDownloadsList[j].name.indexOf(".json") == -1)
        						continue;
        					
				            var localJson = JSON.parse( QT.readFile("../plugins/downloads/"+aDownloadsList[j].name));
	            			if(localJson.id.toLowerCase().trim() == json[i].id.toLowerCase().trim()) {
	            				found = true;
	            				break;
	            			}          		            								
				        }
				        if(!found) {
				        	pluginsToDownload.push(json[i]);
				        }
        			}        			
        		}
        
            	//check if there is a new plugin version
		        for(var i=0; i<aDownloadsList.length; ++i){
		      		
		      		if(aDownloadsList[i].name.indexOf(".json") == -1)
        				continue;
		        	
		            var localJson = JSON.parse( QT.readFile("../plugins/downloads/"+aDownloadsList[i].name));
		            for(var j=0; j<json.length; ++j){
            			if(localJson.id.toLowerCase().trim() == json[j].id.toLowerCase().trim()) {
            				if(parseFloat(localJson.ver) < parseFloat(json[j].ver)) {
            					pluginsToDownload.push(json[j]);        					
            				}
            			}          		
            		}						
		        }
		      	      	
		      	if(pluginsToDownload.length > 0) {
		      		
		   			window["plugins/download"] = new Object();
		      		window["plugins/download"]["plugins"] = pluginsToDownload;
		      		window["plugins/download"]["function"] = downloadPlugin;
	
		      		for(var i =0; i<pluginsToDownload.length; i++) {
					    QT.writeFile("../plugins/downloads/"+ pluginsToDownload[i].id +".json", JSON.stringify(pluginsToDownload[i]));
					}
					downloadPlugin();
					$("#plugins-span-update-found").text(_D("Downloading plugins..."));

		      	}	        
			}
		});
    });
	
    function downloadPlugin() {
		if(window["plugins/download"]["plugins"][0].url != undefined) {
			$("#plugins-span-update-found").text(_D("Downloading ") + window["plugins/download"]["plugins"][0].name);
		QT.downloadFile(window["plugins/download"]["plugins"][0].url,"/data/plugins/"+ window["plugins/download"]["plugins"][0].url.substring(window["plugins/download"]["plugins"][0].url.lastIndexOf("/")+1),
		function(json){		
			if(json.status.toLowerCase() != "download complete"){
				$("#plugins-span-update-found").text(_D("Downloading ") + window["plugins/download"]["plugins"][0].name +" " +parseInt(json["percent"],10)+ "%");
           } else {
           		QT.downloadFile(window["plugins/download"]["plugins"][0].iconurl,"/data/plugins/downloads/"+ window["plugins/download"]["plugins"][0].iconurl.substring(window["plugins/download"]["plugins"][0].iconurl.lastIndexOf("/")+1),
					function(json){
						if(json.status.toLowerCase() == "download complete"){
				           	window["plugins/download"]["plugins"].splice(0,1);
							if(window["plugins/download"]["plugins"].length>0) {
								window["plugins/download"]["function"]();
							} else {
								$("#plugins").dialog("close");
								$("#plugins").dialog("open");
								$("#plugins-span-update-found").text(_D("Plugins downloaded"));
							}
						}
				});        	  	
           }			
        });
       }
	}
    
    $('ul#plugins-list li:first').find(".upload-plugin").click(function() {
    	var $checkbox = $(this);

    	if(!$checkbox.is(':checked'))
        	$('ul#plugins-list li:first').find(".upload-plugin").prop('checked', true);
	});
    
    
    $("#plugins-start-eve-update").on("click", function(e,ui){	

		var checkValues = $('input[name=uploadPlugin]:checked').map(function() {
					return $(this).parent().attr("eve-manager-plugin");
				}).get();
		
		if(checkValues.length == 0) {
			$("#plugins-span-update-to-eve").text(_D("No plugin(s) selected"));
			return;
		}

	    if(QT.eve.isConnect()){
					
			$("#plugins-span-update-to-eve").text("");
			
			if(checkValues.length > 0) {
				
				//automatically include eve logic, since is required for other plugins
				//so checkValues object must be populated again
			/*	$('ul#plugins-list li:first').find(".upload-plugin").prop('checked', true);			
				checkValues = $('input[name=uploadPlugin]:checked').map(function() {
					return $(this).parent().attr("eve-manager-plugin");
				}).get();*/
				
				var pluginsToUpload = new Array();
				
				var splittedCheckValues = checkValues.toString().split(",");		
				splittedCheckValues.push('evelogic'); //evelogic is needed
				
				var aDownloadsList = QT.fileList(QT.applicationPath()+"/data/plugins/downloads/");
				//eve logic as first element
				aDownloadsList=sortLocalPluginsFileName(aDownloadsList);
				
				for(var i=0; i<aDownloadsList.length; ++i){
					
			        if(aDownloadsList[i].name.indexOf(".json") == -1)
						continue;
					
			        var json = JSON.parse( QT.readFile("../plugins/downloads/"+aDownloadsList[i].name));
			        for(var j =0; j< splittedCheckValues.length; j++) {
			        	if(splittedCheckValues[j].toLowerCase().trim() == json.id.toLowerCase()) {
			        		pluginsToUpload.push(json);
			        		break;
			        	}
			        }
			    }
			    
			    if(pluginsToUpload.length > 0) {				
					window["plugins/upload"] = new Object();
					window["plugins/upload"]["plugins"] = pluginsToUpload;
					window["plugins/upload"]["function"] = uploadPluginToEve;
				
					uploadPluginToEve();
					console.log('Plugin(s) upload started: ' + checkValues);
					$("#plugins-span-update-to-eve").text(_D("Installing selected plugin(s) to EVE..."));					
				}
			}
		} else {
            $document.trigger("app/confirm",[_D("You must to be connected to Eve.<br />Connect now?"),function(){
                presenter.getWindow("databaseManager").show(undefined, { "command": "connect" });
            }]);
		}
    });
     
    function uploadPluginToEve() {
    	if(window["plugins/upload"]["plugins"][0].url != undefined) {
			console.log("upload started");
			$("#plugins-span-update-to-eve").text(_D("Installing " + window["plugins/upload"]["plugins"][0].name));	
			eveDesk.EVECreateFolder("logic",
			function(json){
				console.log("logic folder created");
				QT.eve.installPlugin(QT.applicationPath() +"/data/plugins/"+ window["plugins/upload"]["plugins"][0].url.substring(window["plugins/upload"]["plugins"][0].url.lastIndexOf("/")+1), window["plugins/upload"]["plugins"][0].installpath,
				function(json){ //progress
					
					$("#plugins-span-update-to-eve").text(_D("Installing " + window["plugins/upload"]["plugins"][0].name + " " + parseInt(json["percent"],10)+ "%"));			
				},
				function(json){
					window["plugins/upload"]["plugins"].splice(0,1);
					if(window["plugins/upload"]["plugins"].length>0) {
						window["plugins/upload"]["function"]();
					} else {
						eveDesk.EVEMessageSend("exitEvelogic||exitEvelogic|", function(data){console.log("evelogic.exe stopped, waiting for restart...");});
						$("#plugins-span-update-to-eve").text(_D("Selected plugin(s) installed to EVE"));
					}
				});
			});

		}
	}

	$(document).on("PluginsWindowLoaded", function() {
		
		
		if(QT.eve.isConnect()){
			
			eveDesk.EVEMessageSend("pluginListOnConnectedEve||plugins|", function(data){
				
				var splittedMsg = data.split('|');
				
				if(splittedMsg[2] == 'answerPlugins') {
	
					var json = JSON.parse(splittedMsg[3]);
					//console.log(json);
					var plugins = json.list;
					
					for (var i=0; i < plugins.length; i++) {
						
						$("#plugins-list").children('li').each(function(n,v) {
						
							var pluginId=$(this).attr('eve-manager-plugin');
							var pluginVersion = $(this).find('.version').text();
							var pluginName = $(this).find('.name').text();
							
							var pluginInfo = $.extend(true, {}, $(this).data("pluginInfo"));
							
							if(plugins[i].name.toLowerCase().trim() == pluginName.toLowerCase().trim()) {
								$(this).find('.upload-plugin').prop('checked', true);
							}
											
						});
					};	
				}
			});
		} 
	
	});

    //Select project folder
    $("#preferences").on("click",".explore",function(e,ui){
        var $this = $(this);

        var folder = QT.selectFolder(_D("Select folder"));

        if(folder.length < 1){
            return;
        }

        $("#preferences").find(".dir").val(folder);
    });
});