/** Javascript JSON to XML converter
 * 
 */
try{
    console.log("%cStart JSON to XML conversion ","color:DarkSlateBlue");
    
    //Variables declaration
    window["json2xml"] = new Object();
    window["json2xml"]["xml"] = $("<main></main>");
    window["json2xml"]["iidGenerator"] = new EveIdAssign();
    window["json2xml"]["rootNode"] = model["instance"].getUIComponentsRoot();
    
    //Serialization
    window["json2xml"]["serialize"] = function(oNode, iPid, iLevel){
    	//console.log("Serialize "+iLevel);
    	//console.log("iPid "+iPid);
    	//console.log(oNode);

        var oUIComponent = oNode.getData();
       // console.log(oUIComponent);
       // console.log("LEEEEEVEEEEEEL "+oUIComponent.UILevel);
        var oRefNode = model["instance"].getComponentByUid( oUIComponent.referenceUId );
        var oComponent = (oRefNode != undefined)? oRefNode.getData():undefined;
        var type = (oComponent != undefined)?oComponent.getType():"icon";
        var $tag;
		//console.log("Deep: "+oNode.getDeep());
        //var treeLevel = iLevel;
        //console.log("%c"+ iLevel,"background-color:red; color: white;");
        //console.warn(type);

        //console.log( oUIComponent );
        //console.log( oComponent );
        
        //Switch type

        //console.log(type);

        switch(type){
            case "icon":
            	//console.log("Icona trovata");
                $tag = $("<"+ type +"></"+ type +">");
                var oIcon = oUIComponent.getParamVal("icon");
                $tag.attr("index", parseInt( (Math.abs(oIcon.position.x)/oIcon.size.w) + (Math.abs(oIcon.position.y)/oIcon.size.h)*(oIcon.setSize.w/oIcon.size.w) ,10) );
                $tag.attr("color", bigh.rgb2hex(oIcon.color.R,oIcon.color.G,oIcon.color.B).toUpperCase().replace("#","0x") );
                $tag.attr("mode",0);
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;
                
            case "scenario":
				
                //if(){}
                //CASE ICON
              //  console.log(oNode);
               // console.log("level: "+oUIComponent.UILevel);
                if (oUIComponent.UILevel=="level-12" || oUIComponent.UILevel=="level-11")
                {
                	//console.log("aggiungo un'icona");
	                $tag = $("<icon></icon>");
	                var oIcon = oUIComponent.getParamVal("icon");
	                $tag.attr("index", parseInt( (Math.abs(oIcon.position.x)/oIcon.size.w) + (Math.abs(oIcon.position.y)/oIcon.size.h)*(oIcon.setSize.w/oIcon.size.w) ,10) );
	                $tag.attr("color", bigh.rgb2hex(oIcon.color.R,oIcon.color.G,oIcon.color.B).toUpperCase().replace("#","0x") );
	                $tag.attr("mode",1);
	                //$tag.attr("sid",oUIComponent.UId);
	                $tag.attr("sid",oUIComponent.referenceUId);
	                //$tag.attr("sid",oComponent.UId); //DA DECIDERE
	                $tag.text("<name><![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]></name>");
	                //$tag.append($("<name></name>").text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>"));
	                //$tag.append($("<parameters><value>"+ oComponent.getParamVal("value") +"</value></parameters>"));
	                $tag.append($("<parameters><value>0</value></parameters>"));
	               // console.log($tag);
             	
                }
                else
                {
                	//console.log("aggiungo uno scenario");
	                $tag = $("<scene></scene>");
	                var oIcon = oUIComponent.getParamVal("icon");
	                $tag.attr("index", parseInt( (Math.abs(oIcon.position.x)/oIcon.size.w) + (Math.abs(oIcon.position.y)/oIcon.size.h)*(oIcon.setSize.w/oIcon.size.w) ,10) );
	                $tag.attr("color", bigh.rgb2hex(oIcon.color.R,oIcon.color.G,oIcon.color.B).toUpperCase().replace("#","0x") );
	                $tag.attr("mode",1);
	                //$tag.attr("sid",oUIComponent.UId);
	                $tag.attr("sid",oUIComponent.referenceUId);
	                //$tag.attr("sid",oComponent.UId); //DA DECIDERE
	                $tag.text("<![CDATA["+ oUIComponent.getParamVal("name") +"]]>");
	                //$tag.append($("<name></name>").text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>"));
	                //$tag.append($("<parameters><value>"+ oComponent.getParamVal("value") +"</value></parameters>"));
	                //$tag.append($("<parameters><value>0</value></parameters>"));
                	
                }
                //console.log($tag);
                break;
                
            case "thermostat":
                $tag = $("<thermo></thermo>");
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();
                var $name = $("<name></name>");
                //var oIcon = oUIComponent.getParamVal("icon");
                
                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.attr("step",oComponent.getParamVal("step"));
                $name.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                $tag.append($name);
                $tag.append("<parameters><suffix>°C</suffix></parameters>");
                //$tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;
            case "tuner":
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();

                $tag = $("<"+ type +"></"+ type +">");
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.attr("step",oComponent.getParamVal("step"));
                $tag.attr("decs",1);
                break;
            case "timed-thermostat":
                $tag = $("<chrthermo></chrthermo>");
                //var oIcon = oUIComponent.getParamVal("icon");

                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;
            case "rgb-light":
                $tag = $("<rgb></rgb>");
                //var oIcon = oUIComponent.getParamVal("icon");
                
                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;
            case "ipcamera":
                $tag = $("<camera></camera>");
                //var oIcon = oUIComponent.getParamVal("icon");

                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;
            case "lock":
                $tag = $("<pswswitch></pswswitch>");
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();
                //var oIcon = oUIComponent.getParamVal("icon");

                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.attr("rev", ( oComponent.getParamVal("reversed") )?1:0 );
                if (oComponent.getParamVal("password")=="")
                {

                    $tag.attr("psw","1234");

                }
                else{
                    $tag.attr("psw",oComponent.getParamVal("password"));
                }

                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;
            case "seeker":
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();
                var widgetType = oComponent.getParamVal("widget/type");
                console.log("seeker");

                switch(widgetType){
                    case "seeker":

                        var aRef = oComponent.getParamVal("widget/components");
                        console.log(aRef);
                        var sidPrev=aRef[0];
                        var sidNext=aRef[1];
/*
//
                        for(var i=0; i<aRef.length; i++){
                            if(aRef[i]["prev"] != undefined){
                                sidPrev = aRef[i]["prev"];
                            }
                            else if(aRef[i]["next"] != undefined){
                                sidNext = aRef[i]["next"];
                            }
                        }
*/
                        $tag = $("<seeker></seeker>");
                        $tag.attr("sid1",sidPrev);
                        $tag.attr("sid2",sidNext);
                        $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                        console.log($tag);
                        break;
                    default:
                        console.warn("Miss widget type");
                        $tag = $("<null></null>");
                }
                break;
            /*case "prev-next":
                $tag = $("<seeker></seeker>");
               //var oIcon = oUIComponent.getParamVal("icon");

                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;*/
            case "info-color":
                $tag = $("<gfxinfo></gfxinfo>");
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();
                //var oIcon = oUIComponent.getParamVal("icon");

                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                $tag.attr("color0",oComponent.getParamVal("color-0").replace("#","0x"));
                $tag.attr("color1",oComponent.getParamVal("color-1").replace("#","0x"));
                break;
            case "info-text":
                $tag = $("<labelinfo></labelinfo>");
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();
                //var oIcon = oUIComponent.getParamVal("icon");

                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                $tag.attr("color0",oComponent.getParamVal("color-0").replace("#","0x"));
                $tag.attr("color1",oComponent.getParamVal("color-1").replace("#","0x"));
                $tag.attr("text0",oComponent.getParamVal("text-0"));
                $tag.attr("text1",oComponent.getParamVal("text-1"));
                break;
            case "combo":
                $tag = $("<dropdown></dropdown>");
                var $name = $("<name></name>");
                var $parameters = $("<parameters></parameters>");
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();
                var aValues = oComponent.getParamVal("values");
                //var oIcon = oUIComponent.getParamVal("icon");

                //$tag.attr("sid",oUIComponent.UId);
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.attr("ronly", (oComponent.getParamVal("read-only")?1:0) );
                $name.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                $tag.append($name);

                for(var i=0; i<aValues.length; ++i){
                    var $item = $("<item></item>");
                    $item.text("<![CDATA[ "+ aValues[i].description +" ]]>");
                    $parameters.append($item);
                }

                $tag.append($parameters);
                break;
            case "web":

                $tag = $("<web></web>");
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.attr("sizefit",0);
                $tag.attr("rotate",1);


                break;
            case "switch":
            case "pulse":
                $tag = $("<"+ type +"></"+ type +">");
                var oComponent = model["instance"].getComponentByUid(oUIComponent.referenceUId).getData();

                $tag.attr("sid",oUIComponent.referenceUId);
                $tag.attr("rev", ( oComponent.getParamVal("reversed") )?1:0 );
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                break;
            case "slider":
            case "shutter":
            case "info":
            //case "tuner":
                $tag = $("<"+ type +"></"+ type +">");
                $tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                $tag.attr("sid",oUIComponent.referenceUId);
                break;
            default:
                //$tag = $("<"+ type +"></"+ type +">");
                //$tag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
                console.warn("DEFAULT: "+ type);
        }

        $tag.attr("iid", window["json2xml"]["iidGenerator"].getId() );
        //$tag.attr("pid", window["json2xml"]["xml"].attr("iid") );
        $tag.attr("pid", iPid );
        var testPID;
        //$tag.attr("pid", iPid );

        window["json2xml"]["xml"].append($tag);
        
        //Check childrens and levels
       // console.log("livello: "+iLevel);
        if(oUIComponent.UILevel=="level-11"){
        //	console.log("Nel caso di livello 1");
            var oChildNode = oNode.children[0];
		//	console.log("Figlio: ");
		//	console.log(oChildNode);
			
            //Check if exist childrens (if it isn't do not create window or menu level)
            if(oChildNode != undefined){
                var oUIChild = oChildNode.getData();
               // console.log("------------------------>");
               // console.log(oUIChild);
                var oChildRefNode = model["instance"].getComponentByUid( oUIChild.referenceUId );
               // console.log("ID componente: "+oUIChild.referenceUId );
                var oChildRefComponent = (oChildRefNode != undefined)? oChildRefNode.getData():undefined;
                var childType = (oChildRefComponent != undefined)?oChildRefComponent.getType():"icon";
			//	console.log("Type: "+childType );
                var $menuTag = $("<menu></menu>");
                if (oUIChild.UILevel=="level-12")
                	$menuTag = $("<menu></menu>");
                else
                	$menuTag = $("<window></window>");
                

                if(childType == "icon" || childType=="scenario" ){
                    var $windowTag = $menuTag;
                    $menuTag.attr("iid", window["json2xml"]["iidGenerator"].getId() );
                    $menuTag.attr("pid", $tag.attr("iid") );
                    $menuTag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");

                    window["json2xml"]["xml"].append($windowTag);

                    testPID = $menuTag.attr("iid");
                }
                else{
                    var $windowTag = $("<window></window>");
                    $windowTag.attr("iid", window["json2xml"]["iidGenerator"].getId() );
                    $windowTag.attr("pid", $tag.attr("iid") );
                    $windowTag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");

                    window["json2xml"]["xml"].append($windowTag);

                    testPID = $windowTag.attr("iid");
                }
            }
        }
        else
        {
            if(oNode.children.length > 0){

                $windowTag = $("<window></window>");
                $windowTag.attr("iid", window["json2xml"]["iidGenerator"].getId() );
                $windowTag.attr("pid", $tag.attr("iid") );
                $windowTag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");

                window["json2xml"]["xml"].append($windowTag);

                testPID = $windowTag.attr("iid");
            }
        }
         
        /*if(oNode.children.length > 0){


            $windowTag = $("<window></window>");
            $windowTag.attr("iid", window["json2xml"]["iidGenerator"].getId() );
            $windowTag.attr("pid", $tag.attr("iid") );
            $windowTag.text("<![CDATA[ "+ oUIComponent.getParamVal("name") +" ]]>");
            
            window["json2xml"]["xml"].append($windowTag);

        }*/
        
        //Recursion
        for(var i=0; i<oNode.children.length; ++i){
          //  console.log("Entra in ricorsivo "+iPid);
            window["json2xml"]["serialize"]( oNode.children[i], testPID, (iLevel + 1) );
        }
        
    };//end function;

    window["json2xml"]["xml"].attr("pid", window["json2xml"]["iidGenerator"].getId());      //Set main "pid" attribute
    window["json2xml"]["xml"].attr("iid", window["json2xml"]["iidGenerator"].getId());      //Set main "iid" attribute
    
    for(var i=0; i<window["json2xml"]["rootNode"].children.length; ++i){
       // console.log("prossima voce for ricorsivo principale");
        window["json2xml"]["serialize"]( window["json2xml"]["rootNode"].children[i], window["json2xml"]["xml"].attr("iid"), 1);
		
    }
    
    //Add "uiinterface" tag
    window["json2xml"]["xml"] = $("<uinterface></uinterface>").append(window["json2xml"]["xml"]);
    //console.log(window["json2xml"]["xml"]);
    //console.warn( window["json2xml"]["xml"][0] );
    //console.warn( bigh.decodeHtmlSpecialChar( window["json2xml"]["xml"][0].outerHTML ) );
    var oUserNode = model["instance"].getSelectUser();
    //console.log(window["json2xml"]["xml"][0].outerHTML);
    //console.log(oUserNode.getData());

    oUserNode.getData().setUIxml( bigh.decodeHtmlSpecialChar( window["json2xml"]["xml"][0].outerHTML ) );
	console.log(bigh.decodeHtmlSpecialChar( window["json2xml"]["xml"][0].outerHTML));
    //Debug
    //QT.writeFile("./INTERFACE.xml", bigh.decodeHtmlSpecialChar( window["json2xml"]["xml"][0].outerHTML ) );
    //QT.writeFile("./demo.xml", bigh.decodeHtmlSpecialChar( window["json2xml"]["xml"][0].outerHTML ) );

    //Remove global variable
    delete window["json2xml"];
    
    console.log("%cStop JSON to XML conversion","color:DarkSlateBlue");
}
catch(err){
    console.error(err);
    alert("JSON to XML conversion error");
}